package com.example.shooter;

import javafx.geometry.Point2D;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.transform.Translate;

import static com.example.shooter.Constants.*;

public class Bullet extends Circle {
	private Translate position;
	private Point2D speed;
	
	public Bullet ( double radius, Translate position, Point2D speed ) {
		super ( radius, Color.ORANGE );
		
		this.position = position;
		this.speed    = speed;
		
		super.getTransforms ( ).add ( this.position );
	}
	
	public boolean update ( long dns, double left, double right, double up, double down ) {
		double newX = this.position.getX ( ) + this.speed.getX ( ) * BULLET_SPEED;
		double newY = this.position.getY ( ) + this.speed.getY ( ) * BULLET_SPEED;
		
		this.position.setX ( newX );
		this.position.setY ( newY );
		
		double radius = super.getRadius ( );
		
		boolean isXOutOfBounds = newX <= ( left - radius ) || newX >= ( right + radius );
		boolean isYOutOfBounds = newY <= ( up - radius ) || newY >= ( down + radius );
		
		return isXOutOfBounds && isYOutOfBounds;
	}
}
